明经CAD社区

 找回密码
 注册

QQ登录

只需一步,快速开始

搜索
查看: 840|回复: 8

[源码] 使用ObjectDBX打开文件,需要判断该文件是否已经打开

[复制链接]
发表于 2019-6-17 09:09 | 显示全部楼层 |阅读模式
本帖最后由 林霄云 于 2019-6-27 09:47 编辑

复制非打开文件的特定块至本图 等自定义操作时,都是默认该文件未打开。当该文件打开时,会产生错误。因此在逻辑上应该先判断该文件是否已经打开。如果已经打开,则不再需要按objectdbx的方式进行vla-open,直接在打开的docs里取得该doc对象即可。
  1. (if (not (hasopened DwgName))
  2.   (progn
  3.   (setq dbxDoc (vla-GetInterfaceObject *acad* (GetObjectDBXVer)));
  4.   (vla-open dbxDoc DwgName)
  5.   );progn
  6.   (progn
  7.   (setq dbxDoc (vla-item *docs* (strcat (vl-filename-base DwgName)(vl-filename-extension DwgName))))
  8.   )
  9.   );if 根据文件是否打开判断,采用合适的doc对象


其中判断文件是否打开自定义函数如下:
  1. (defun hasopened( dwgname / *ACAD* *DOC* *DOCS*  flag doc)
  2.   ;返回dwgname是否已经打开
  3.   ;designed by 林霄云 2019年6月5日
  4.   (setq        *ACAD* (vlax-get-acad-object)
  5.         ;*DOC*  (vla-get-ActiveDocument *acad*)
  6.         *DOCS* (vla-get-Documents *ACAD*)
  7.     flag nil
  8.     dwgname (findfile dwgname)
  9.   )
  10.   
  11.     (vlax-for  doc   *DOCS*
  12.        (if (= dwgname (vla-get-fullname doc))
  13.            (setq flag T)
  14.           ) ;if
  15.     );vlax-for
  16.   flag
  17. );defun




"觉得好,就打赏"
还没有人打赏,支持一下
发表于 2019-6-17 12:17 | 显示全部楼层
不一定是当前CAD打开的
还有一种可能是设为只读文件
发表于 2019-6-21 15:26 | 显示全部楼层
来晚了,来晚了,林大大出山了……
发表于 2019-6-21 17:17 | 显示全部楼层
GetObjectDBXVer  能发下这个子函数吗?
 楼主| 发表于 2019-6-25 15:09 | 显示全部楼层
本帖最后由 林霄云 于 2019-6-27 09:48 编辑
taoyi0727 发表于 2019-6-21 17:17
GetObjectDBXVer  能发下这个子函数吗?
  1. ;;154.1 [功能] 获取ObjectDBX版本字符串
  2. ;;用于操作非打开文件
  3. (defun GetObjectDBXVer (/ VERSION)
  4.   (if (>= (setq VERSION (atoi (getvar "acadver"))) 16)
  5.     (strcat "ObjectDBX.AxDbDocument." (itoa VERSION))
  6.   )
  7. )


 楼主| 发表于 2019-6-25 15:10 | 显示全部楼层
为何不能正常显示代码块?
发表于 2019-6-25 16:06 | 显示全部楼层

谢谢

你看到你这个自己改了一下
;;说明:判断指定CAD文件是否已经打开
;;参数:dwgname:路径+文件名+后缀 [str]
;;返回:t or nil
;;用法T-judge-dwg-file-state "E:\\桌面\\硬包.dwg")
(defun T-judge-dwg-file-state (dwgname / docs flag)
        (setq DOCS (vla-get-Documents (vlax-get-acad-object)));所有CAD文件档集合
        (vlax-for doc DOCS
                (if (= (strcase dwgname) (strcase (vla-get-fullname doc)));获取文档的路径+名称
                        (setq flag T)
                )
        )
        flag
)
 楼主| 发表于 2019-6-27 09:50 | 显示全部楼层
林霄云 发表于 2019-6-25 15:10
为何不能正常显示代码块?

代码如果自动识别,增加了一个多余的引号,即[code="lisp];手动选择lisp语言,为[code=lisp],能正确显示。
您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号 )  
©2000-2023 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2024-4-20 20:55 , Processed in 0.217453 second(s), 30 queries , Gzip On.

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

快速回复 返回顶部 返回列表